// RO-Aufgabe1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>

// 7 ASM-Befehle
unsigned int fac_iter(unsigned int n){
	__asm{
			MOV ECX, n	// Fakulttszahl n nach ECX laden
			MOV EAX, 1	// lade 1 als mglichen Rckgabewert bzw. fr die akkumulierende Multiplikation
	again:	
			CMP ECX, 1	// Fakulttszahl == 1 ?
			JLE	end		// wenn n <= 1, dann Ende (dadurch: fac_iter(0) = fac_iter(1) = 1)
			MUL ECX		// bestimme: EAX = EAX * n
			DEC ECX		// dek. zu n-1
			JMP again	// weiter mit Multiplikation mit n-1 oder Abbruch
	end:
	}
}

// 10 ASM-Befehle
unsigned int fac_rec(unsigned int n){
	__asm{
		MOV ECX, n		// lade Fakulttszahl n
		MOV EAX, 1		// lade 1 als mglichen Rckgabewert bzw. fr die akkumulierende Multiplikation

		CMP ECX, 1		// n == 1 ?
		JLE end			// n<=1, dann Ende (Ergebnis ist EAX=1)

		DEC ECX			// dek. zu n-1
		
		PUSH ECX		// n-1 auf den Stack (als Argument fr Funktion)
		CALL fac_rec	// bestimme: EAX = fac(n-1)
		POP ECX			// n-1 vom Stack nehmen

		INC ECX			// ink. zu n
		MUL ECX			// Multiplikation der vorherigen Fakultt mit der aktuellen Fakulttszahl:
						// EAX = fac(n-1) * ECX
	end:
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	printf("Fakultaet iterativ von %u: %u\n", 20, fac_iter(20));
	printf("Fakultaet rekursiv von %u: %u\n", 20, fac_rec(20));
	return 0;
}
