// RO-Aufgabe2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>

unsigned int fibo(unsigned int n){
	__asm{
		MOV EAX, 1	// Startwert fr fibo in EAX laden
		MOV EDX, n	// fibo-Indexzahl in EDX laden
		CMP EDX, 2	// Vergleich mit 2
		JLE end		// alle n<=2 sollen 1 als Rckgabewert haben

		// n ist nicht kleiner oder gleich 2
		DEC EDX		// dekrementiere Index (zu n-1)
		
		PUSH EDX	// n-1 aufn Stack (fr Funktionsaufruf)
		CALL fibo	// bestimme: EAX = fibo(n-1)
		POP EDX		// n-1 nach EDX
		
		PUSH EAX	// *1: sichere fibo(n-1)

		DEC EDX		// dekrementiere Index (jetzt: n-2)
		PUSH EDX	// n-2 aufn Stack (fr Funktionsaufruf)
		CALL fibo	// bestimme: EAX = fibo(n-2)
		
		POP EDX		// n-2 vom Stack (nur zum Aufrumen)

		POP EDX		// lese fibo(n-1) vom Stack (siehe *1)

		ADD EAX, EDX	// EAX = fibo(n-2) + fibo(n-1)
	end:
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	printf("Fibonacci-Zahl von %i: %i\n", 7, fibo(7));
	return 0;
}

